<?php
/*
 *	Xdebug Trace Viewer
 *	-------------------
 *	Ce script sert  visualiser des traces XDebug (crs par la fonction xdebug_start_trace()).
 *	Les traces Xdebug doivent tre enregistres dans le mode XDEBUG_TRACE_COMPUTERIZED.
 *
 *	Utilisation
 *	-----------
 *	Placez simplement ce script dans le dossier contenant vos traces Xdebug (fichiers .xt),
 *	et accedez-y via un navigateur (exemple: http://localhost/Xdebug/XdebugViewer.php).
 *	Le script liste automatiquement les fichiers .xt qui se trouvent dans le mme rpertoire,
 *	il suffit de cliquer sur la trace pour visualiser son contenu.
 *
 *	Gnration de trace
 *	-------------------
 *	Pour gnrer une trace xdebug, utilise ce code :
 ini_set('xdebug.trace_output_dir', 'J:\MULTI\__VIEWER');
 ini_set('xdebug.trace_output_name', 'phpbb_trace_%u');
 xdebug_start_trace(null, XDEBUG_TRACE_COMPUTERIZED);

 *	Ou encore, plus simplement :
 xdebug_start_trace('J:\MULTI\__VIEWER', XDEBUG_TRACE_COMPUTERIZED);

 *	Date : 07/01/2012 14:43:00
 *	PHP 5.2.10
 *	 2012 mrschnaps.com
**/
function display_trace(){
	$display_filename = isset($_GET['xt']) ? $_GET['xt'] : null;
	
	# Aucun paramtre => listing fichiers
	if( empty($display_filename) ){
		echo '<p>Aucun fichier  afficher.</p>';
		
		# Liste des fichiers du rpertoire
		echo '<p>Choisissez un fichier  afficher :</p><ul>';
		$handle = opendir(dirname(__FILE__));
		while( false !== ($file = readdir($handle)) ){
			if( is_file($file) AND preg_match('#\.xt$#i',$file) ){
				$url = $_SERVER['PHP_SELF'].'?xt='.urlencode($file);
				echo "<li><a href=\"$url\">$file</a></li>\n";
			}
		}
		echo '</ul>';
		return;
	}
	
	echo "<h1>$display_filename</h1>";
	
	# Constantes de lecture d'une ligne de trace (cf http://xdebug.org/docs/execution_trace) :
	define('XD_LEVEL'			, 0);
	define('XD_FUNCTION_NUM'	, 1);
	define('XD_EXIT'			, 2);
	define('XD_TIME'			, 3);
	define('XD_MEMORY'			, 4);
	define('XD_FUNCTION_NAME'	, 5);
	define('XD_TYPE'			, 6);
	define('XD_INCLUDE_NAME'	, 7);
	define('XD_FILENAME'		, 8);
	define('XD_LINE'			, 9);
	
	?>
	<table class="xdebug-trace" border="1">
	<tr>
		<th>#</th>
		<th>Function</th>
		<th>Include</th>
		<th>File</th>
		<th>Line</th>
	</tr>
	<?php
	$exclude_functions = array(
		'dbal_mysqli->sql_fetchrow',
		'dbal->sql_add_num_queries',
		'msg_handler',
		'acm->sql_fetchrow',
		'utf8_htmlspecialchars',
		'phpbb_seo->url_rewrite',
		'stripslashes_deep',
		'append_sid',
		'request_var',
	);
	
	$handle = fopen( dirname(__FILE__).'/'.$display_filename , 'r' );
	$i = 0;
	while( !feof($handle) )
	{
		$aRow = explode("\t", fgets($handle));
		
		# Condition 1 : On affiche seulement les lignes de type Entry, pas Exit
		# Condition 2 : On affiche seulement les fonctions "user-defined"
		# Condition 3 : Exclusion de certaines fonctions dans $$exclude_functions
		if( sizeof($aRow) > 6 AND $aRow[XD_TYPE] == '1' AND !in_array($aRow[XD_FUNCTION_NAME],$exclude_functions) ){
			$i++;
			
			$level_spacer = str_pad('',$aRow[XD_LEVEL]-2,'*'); # -2 pour virer le level 2 ds le premier appel
			$level_spacer = str_replace('*','  ',$level_spacer);
			
			echo '
			<tr>
				<td>'.$i.'</td>
				<td>'.$level_spacer.$aRow[XD_FUNCTION_NAME].'</td>
				<td>'.$aRow[XD_INCLUDE_NAME].'</td>
				<td>'.$aRow[XD_FILENAME].'</td>
				<td>'.$aRow[XD_LINE].'</td>
			</tr>
			';
		}
	}
	fclose($handle);
	?>
	</table>
	<?php
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Xdebug Viewer</title>

<style 	type="text/css">
body{font:10pt Arial, Helvetica, sans-serif; background:whitesmoke;}
.xdebug-trace{border-collapse:collapse;}
td{padding:6px 8px; background:white;}
th{background:silver; padding:10px;}
tr td:nth-child(2){font:10pt "Courier New", Courier, monospace; white-space:pre;}
</style>

</head>

<body>
<?php display_trace(); ?>

<p>&copy 2012 <a href="http://mrschnaps.com/#source=XdebugViewer">mrschnaps.com</a></p>
</body>
</html>